package edu.lawrence.questionsfx;

import edu.lawrence.questions.Question;
import edu.lawrence.questions.QuizDAO;
import java.net.URL;
import java.util.ResourceBundle;
import javafx.event.ActionEvent;
import javafx.fxml.FXML;
import javafx.fxml.Initializable;
import javafx.scene.control.TextArea;
import javafx.scene.control.TextField;

public class FXMLEditQuestionDialogController implements Initializable {
    private QuizDAO dao;
    
    @FXML
    private TextField subject;
    @FXML
    private TextArea question;
    @FXML
    private TextField choices;
    @FXML
    private TextField answer;
    
    private Question questionObj;
    
    public void setDAO(QuizDAO dao) {
        this.dao = dao;
    }
    
    public void setQuestion(Question q) {
        this.questionObj = q;
        if(questionObj != null) {
            subject.setText(questionObj.getSubject());
            question.setText(questionObj.getQuestion());
            choices.setText(questionObj.getChoices());
            answer.setText(questionObj.getAnswer());
        }
    }
    
    @FXML
    private void cancelDialog(ActionEvent event) {
        subject.getScene().getWindow().hide();
    }
    
    @FXML
    private void acceptDialog(ActionEvent event) {
        String subjectTxt = subject.getText();
        String questionTxt = question.getText();
        String choicesTxt = choices.getText();
        String answerTxt = answer.getText();
        if(questionObj == null) {
            questionObj = new Question(subjectTxt,questionTxt,choicesTxt,answerTxt);
            dao.addQuestion(questionObj);
        } else {
            questionObj.setSubject(subjectTxt);
            questionObj.setQuestion(questionTxt);
            questionObj.setChoices(choicesTxt);
            questionObj.setAnswer(answerTxt);
            dao.updateQuestion(questionObj);
        }
        subject.getScene().getWindow().hide();
    }
    
    @Override
    public void initialize(URL url, ResourceBundle rb) {
    }    
    
}
